/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.caja;

import danielcortes.xyz.data.ConnectionHolder;
import danielcortes.xyz.data.SQLiteConnectionHolder;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

public abstract class CajaDAO {
    protected ConnectionHolder connectionHolder;

    public abstract List<Caja> findAll();
    public abstract Caja findById(int id);
    public abstract Caja findByFecha(LocalDate fecha);
    public abstract boolean insertCaja(Caja caja);
    public abstract boolean updateCaja(Caja caja);

    public abstract void createCajasForMonth(LocalDate month);

    protected List<Caja> cajasFromResultSet(ResultSet rs) throws SQLException {
        List<Caja> cajaList = new ArrayList<>();
        while (rs.next()) {
            Caja caja = new Caja();
            caja.setId(rs.getInt("id"));
            caja.setFecha(LocalDate.parse(rs.getString("fecha")));
            cajaList.add(caja);
        }
        return cajaList;
    }
}
